function [pl val] = bilinsvmpredict(X, model)
%
% Bilinear classification
%  [pl val] = bilinsvmpredict(X, model)
%
% Input:
%  X   - Feature matrices      [h x w x #test]
%        NOTE: samples are given in the form of "matrix (h x w)".
%  model  - Classifier model produced by `bilinsvmtrain.m'
%
% Output:
%  pl  - Predicted label vector {-1,+1} [#test x 1]
%  val - Classification values          [#test x 1]
%

val = squeeze(sum(sum(bsxfun(@times, x, model.W)))) - model.rho;
pl  = 2*double(val>0)-1;
