function [alpha rho cost] = svmbysmo(y, X, C)
%
% Linear SVM training by SMO
%  [alpha rho cost] svmbysmo(y, X, C)
%
% Input:
%  y - Label vector {-1,+1}  [n x 1]
%  X - Sample column vectors [dim x n]
%  C - Cost parameter        [scalar]
%
% Output:
%  alpha - Dual coefficients [n x 1]
%  rho   - Bias value        [scalar]
%  cost  - Objective cost    [scalar]
%

n = size(X,2);
[alpha stats]= smo(y, transpose(X)*X, -ones(n,1), [], zeros(n,1), struct('c',C, 'q',1, 'm',1000));
rho  = stats.rho;
cost = -stats.cost;
