addpath('../SMO');

%- Toy data -%
y = [ones(100,1);-ones(100,1)];
X = zeros(100,100,200);
X(1:50,:,1:100)=1;
X(51:100,:,101:200)=1;

rng(0);
for i = 1:200
	nrand = 60;
	val = double(rand(nrand,1)>0.5);
	jc = randi([1,95],nrand,1);
	ir = randi([1,95],nrand,1);
	jcs = jc; jce = jc+5;
	irs = ir; ire = ir+5;
	for j = 1:nrand
		if (i<=100 && irs(j)<=45 && val(j)==1) ||...
		   (i<=100 && irs(j)> 45 && val(j)==0) ||...
		   (i> 100 && irs(j)<=45 && val(j)==0) ||...
		   (i> 100 && irs(j)> 45 && val(j)==1) 
			continue; 
		end
		X(irs(j):ire(j),jcs(j):jce(j),i) = val(j);
	end
end
%implay(X)

%- Bilinear training -%
C  = 1;
Jh = smooth_regularizer(size(X,1),'1st'); Jh = Jh/norm(Jh);
Jw = smooth_regularizer(size(X,2),'1st'); Jw = Jw/norm(Jw);
Ww0= initw(y, X, struct('C',C, 'svmsolver',@svmbysmo));
model       = bilinsvmtrain(y, X, struct('C',C, 'Ww0',Ww0, 'svmsolver',@svmbysmo, 'verbose',1));
modelsmooth = bilinsvmtrain(y, X, struct('C',C, 'Ww0',Ww0, 'svmsolver',@svmbysmo, 'verbose',1, 'Jh',Jh, 'Jw',Jw));

%- Classifier results -%
figure('name','classifier weight');
subplot(1,2,1);im1=imshow(model.W,[]);title(sprintf('C=%d, rank=%d',C,size(model.Ww,2)));
subplot(1,2,2);im2=imshow(modelsmooth.W,[]);title(sprintf('C=%d with smooth, rank=%d',C,size(modelsmooth.Ww,2)));
colormap(jet);

rmpath('../SMO');
